# CMF compatibility
# this is split between CMF.py, CMFInit.py and Extensions/CMFInstall.py
# (unfortunately) and it's still not right (need to import makeCMFWikiPage
# for PUT_factory). Try circular imports ?
# move CMFInstall into the skin ?

__version__="$Revision: 1.6 $"[11:-2]

from types import *
import string, re, os
from AccessControl import ClassSecurityInfo
from OFS.DTMLDocument import DTMLDocument
from Products.CMFCore.PortalContent import PortalContent
from Products.CMFCore.utils import _getViewFor
from Products.CMFDefault.SkinnedFolder import SkinnedFolder
from Products import CMFDefault
from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl
import Permissions
from Defaults import PAGE_PORTALTYPE, WIKI_PORTALTYPE, WIKI_METATYPE

# I don't understand what's going on with CMFWiki's permissions &
# regulations compared to WFN's (which we already have in Regulations.py),
# left out for the moment

class CMFAwareness(PortalContent, DefaultDublinCoreImpl):
    """
    Mix-in class for CMF support
    """
    portal_type = PAGE_PORTALTYPE
    # provide this so DublinCore.Format works with old instances
    format = 'text/html'

    # permission defaults
    security = ClassSecurityInfo()
    set = security.setPermissionDefault
    set(Permissions.Edit, ('Owner', 'Manager', 'Authenticated'))
    set(Permissions.FTPRead, ('Owner', 'Manager'))
    set(Permissions.Regulate, ('Owner', 'Manager'))
    set(Permissions.Create, ('Owner', 'Manager', 'Authenticated'))
    set(Permissions.Move, ('Owner', 'Manager'))
    set(Permissions.Comment, ('Owner', 'Manager', 'Authenticated'))
    set = None

    def inCMF(self):
        """return true if this page is in a CMF portal"""
        return hasattr(self.aq_inner.aq_parent,'portal_membership')

    def __init__(self, source_string='', mapping=None, __name__=''):
        DTMLDocument.__init__(self,
                              source_string=source_string,
                              mapping=mapping,
                              __name__=__name__,
                              )
        DefaultDublinCoreImpl.__init__(self)

    security.declarePublic('getId')
    def getId(self):
        try: return self.id()
        except TypeError: return self.id

    security.declareProtected(Permissions.View, 'SearchableText')
    def SearchableText(self):
        return self.text()

    # XXX ZWikiPage.__call__ is taking precedence right now
    #security.declareProtected(Permissions.View, '__call__')
    #def __call__(self, client=None, REQUEST={}, RESPONSE=None, **kw):
    #    '''
    #    Invokes the default view.
    #    '''
    #    view = _getViewFor( self )
    #    if getattr(aq_base(view), 'isDocTemp', 0):
    #        return apply(view, (self, REQUEST))
    #    else:
    #        if REQUEST:
    #            kw[ 'REQUEST' ] = REQUEST
    #        if RESPONSE:
    #            kw[ 'RESPONSE' ] = RESPONSE
    #
    #        return apply( view, (self,), kw )

    #RENDERERS = {
    #    'html'                : render_html,
    #    }
    def render( self, client=None, REQUEST={}, RESPONSE=None, **kw ):
        """
        Determine the appropriate renderer, and call it.
        """
        #renderer = self.RENDERERS[ self.page_type ]
        #if client is None:
        #    client = self
        #return apply( renderer, ( self, client, REQUEST, RESPONSE ), kw )
        return apply(self._renderMethod(),(self, REQUEST, RESPONSE), kw)

    def wiki_context(self, REQUEST=None, with_siblings=0):
        return self.context(REQUEST, with_siblings)

class CMFWikiFolder( SkinnedFolder ):
    meta_type=WIKI_METATYPE

    def PUT_factory(self, name, typ, body):
        if find(typ, 'text') != -1:
            return makeCMFWikiPage(name, '', body) #XXX bug! need to import

    def Title(self): # for CMFCatalog
        fp = getattr( self, 'FrontPage', None )
        return fp and fp.Title() or self.title_or_id()

